double floor(double x)

	{

	int cnt = x;

	if (cnt > x) cnt--;

	return (double) cnt;

	}



double sqrt(double x)

        {

        int cnt = 0;

        double y = x;

        if (x==0.0) return 0.0;

        do

            {

            y = (y + x/y)/2.0;

            }

        while (++cnt < 64 && (y*y != x));

        return y;

        }



double fabs(double x)

        {

        if (x < 0) return -x;

        return x;

        }



double atan(double x){

	double a, b, c, d, e, f, g, s, t;

	if(x==0) return(0);

	if(x==1) {

                 return(.78539816339744830961566084582);

		}

	f=1;

	while(x > .5){

		x= -(1-sqrt(1.+x*x))/x;

		f=f*2;

	}

	while(x < -.5){

		x = -(1-sqrt(1.+x*x))/x;

		f=f*2;

	}

	s = -x*x;

	b = f;

	c = f;

	d = 1;

	e = 1;

	for(a=3;1==1;a=a+2){

		b=b*s;

		c=c*a+d*b;

		d=d*a;

		g=c/d;

		if(g==e){

			return(x*c/d);

		}

		e=g;

	}

}



double exp(double x){

	double a, b, c, d, e, g, t, w, y;



	w = 0;

	if(x<0){

		x = -x;

		w = 1;

	}

	y = 0;

	while(x>2){

		x = x/2;

		y = y + 1;

	}



	a=1;

	b=1;

	c=b;

	d=1;

	e=1;

	for(a=1;1==1;a++){

		b=b*x;

		c=c*a+b;

		d=d*a;

		g = c/d;

		if(g == e){

			g = g/1;

			while(y--){

				g = g*g;

			}

			if(w==1) return(1/g);

			return(g/1);

		}

		e=g;

	}

}



double log(double x){

	double a, b, c, d, e, f, g, u, s, t;

	if(x <=0) return(-1);



	f=1;

	while(x > 2){

		x = sqrt(x);

		f=f*2;

	}

	while(x < .5){

		x = sqrt(x);

		f=f*2;

	}



	u = (x-1)/(x+1);



	s = u*u;

	b = 2*f;

	c = b;

	d = 1;

	e = 1;

	for(a=3;1==1;a=a+2){

		b=b*s;

		c=c*a+d*b;

		d=d*a;

		g=c/d;

		if(g==e){

			return(u*c/d);

		}

		e=g;

	}

}



double sin(x){

	double a, b, c, s, t, y, p, n, i;

	y = x/.7853;

	p = atan(1);



	if(x>=0) n = (x/(2*p)+1)/2;

	if(x<0) n = (x/(2*p)-1)/2;

	x = x - 4*n*p;

	if((int)n%2!=0) x = -x;



	y = -x*x;

	a = x;

	b = 1;

	s = x;

	for(i=3; 1==1; i=i+2){

		a = a*y;

		b = b*i*(i-1);

		c = a/b;

		if(c==0) return(s/1);

		s = s+c;

	}

}



double cos(double x){

	double t;

	x = sin(x+2*atan(1));

	return(x/1);

}



double pow(double x, double y)

	{

	int yy = y;

	if (x < 0)

		{

		x = pow(-x, y);

		if (yy == y)

			{

			if (yy&1) x = -x;

			return x;

			}

		}

	else if (x == 0)

		{

		if (y > 0) return 0;

		}

	else

		{

		return exp(log(x)*y);

		}

	return -1.7e38;

	}

