# include <stdio.h>
# include <Types.h>
# include <Resources.h>
# include <Errors.h>
# include <OSUtils.h>

# include <sys/types.h>
# include <netdb.h>
# include <netinet/in.h>
# include <sys/socket.h>
# include <sys/time.h>
# include <neterrno.h>

# include "sock_str.h"
# include "sock_int.h"

#include <ctype.h>
#include <a_namesr.h>
#include <sys/param.h>
#include <sock_ext.h>

struct	sockaddr_in server_name,data_addr;

int fd_stdin;

extern int errno;

int result, flags;
int oursock, hissock;
char	line[BUFSIZ];
char	ibuf[1024];
int	inptr, ilen;

_main(int argc, char **argv)
	{
	struct hostent *host;
	struct servent *sp;
	int s;

	sp = getservbyname("ftp", "tcp");
	server_name.sin_port = sp->s_port;
	
	oursock = s_socket(AF_INET, SOCK_STREAM, 0);
	hissock = s_socket(AF_INET, SOCK_STREAM, 0);
	
	gethostname(line, sizeof(line));

	host = gethostbyname(line);
	if (!host) kprintf("gethostbyname err\n"),exit(4);
	memcpy(&data_addr.sin_addr, host->h_addr_list[0], host->h_length);

	host = gethostbyname(argv[1]);
	if (!host) kprintf("gethostbyname err\n"),exit(5);
	
	server_name.sin_family = AF_INET;
	memcpy(&server_name.sin_addr, host->h_addr_list[0], host->h_length);

	if (s_connect(hissock, &server_name, sizeof(struct sockaddr_in)))
		kprintf("connect err\n"),exit(1);

	s_read(hissock, line, sizeof(line));
	
	kprintf("Response = %s\n", line);
	s_close(hissock);
	}
