#include "crtlocal.h"
#include <sys/types.h>
#include <sys/stat.h>

int chmod(const char *name, mode_t flags)
		{
    	OSErr   err;
    	FInfo info;
    	FSSpec name1 = hfs_canon(crt, name, 1);
    	if (!*name1.name) return -1;
    	err = FSpGetFInfo(&name1, &info);
        if (!err)
        	{
        	info.fdFlags &= ~0xE;
        	info.fdFlags |= ((flags&1)<<1)|((flags&8)>>1)|((flags&64)>>3);
        	err = FSpSetFInfo(&name1, &info);
        	}
    	return err?-1:0;
		}
	
