#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>

main(int argc, char **argv)
	{
        char *buf;
        int cnt,err;
        struct stat statbuf;
	int fd = open("a.out", O_CREAT|O_WRONLY);
        int in = open(argv[0], O_RDONLY);
        if (fd==-1) perror("a.out"),exit(-1);
        if (in==-1) perror(argv[0]),exit(-2);
        err = fstat(in, &statbuf);
        if (err) perror("fstat"),exit(1);
        buf = malloc(statbuf.st_size);
        if (!buf) perror("malloc"),exit(2);
        cnt = read(in, buf, statbuf.st_size);
        if (cnt==-1) perror("read"),exit(3);
        else printf("Read %d bytes\n", cnt);
        cnt = write(fd, buf, cnt);
        if (cnt==-1) perror("write"),exit(4);
        else printf("Wrote %d bytes\n", cnt);
	close(fd); close(in);
        exit(0);
	}
